#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{

    int n, k, cmax, brojac_k;

    cin >> n >> k >> cmax;

    long niz[n], a, suma, tek_suma;

    for(int i=0; i<n; i++){
        cin >> a;
        niz[i] = a;
    }

    vector<long> zbir_podnizova;

    brojac_k = 0;

    for(int i=0; i<n-k+1; i++){
        suma = 0;
        tek_suma = 0;
        for(int j=i; j<k+i; j++){
            suma = suma + niz[j];
        }

        tek_suma = suma;
        for(int z=i; z<k+i-1; z++){
            tek_suma = tek_suma - niz[z];
            zbir_podnizova.push_back(tek_suma);
        }
        sort(zbir_podnizova.begin(), zbir_podnizova.end(), greater<long>());
        for(int y=brojac_k; y<brojac_k+cmax-1; y++){
            suma = suma + zbir_podnizova[y];
        }
        if(suma < suma - zbir_podnizova[brojac_k+cmax-2]){
            suma = suma - zbir_podnizova[brojac_k+cmax-2];
        }
        cout << suma << " ";
        brojac_k = brojac_k + k-1;
    }

    return 0;
}